vi: fixes to string search in colon commands, closes 10321
[oweals/busybox.git] / scripts / trylink
index 4fea6fe765b7617d203b8b24f3bfbcab052e5730..bb6b2de2f6c96d55987a8b8b9bd32f3343b28b8c 100755 (executable)
@@ -41,28 +41,86 @@ try() {
     printf "%s\n" "$*" >>$EXE.out
     printf "%s\n" "==========" >>$EXE.out
     $debug && echo "Trying: $*"
-    "$@" >>$EXE.out 2>&1
+    $@ >>$EXE.out 2>&1
+    return $?
+}
+
+check_cc() {
+    tempname="$(mktemp tmp.XXXXXXXXXX)"
+    echo "int main(int argc,char**argv){return argv?argc:0;}" >"$tempname".c
+    # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
+    # Was using "-xc /dev/null", but we need a valid C program.
+    # "eval" may be needed if CFLAGS can contain
+    # '... -D"BB_VER=KBUILD_STR(1.N.M)" ...'
+    # and we need shell to process quotes!
+    $CC $CFLAGS $LDFLAGS $1 "$tempname".c -o "$tempname" >/dev/null 2>&1
     exitcode=$?
+    rm -f "$tempname" "$tempname".c "$tempname".o
     return $exitcode
 }
 
-check_cc() {
-    if $CC $1 -shared -o /dev/null -xc /dev/null > /dev/null 2>&1; then
-        echo "$1";
-    else
-        echo "$2";
-    fi
+check_libc_is_glibc() {
+    tempname="$(mktemp tmp.XXXXXXXXXX)"
+    echo "\
+       #include <stdlib.h>
+       /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
+       #if defined(__GLIBC__) && !defined(__UCLIBC__)
+       syntax error here
+       #endif
+       " >"$tempname".c
+    ! $CC $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1
+    exitcode=$?
+    rm -f "$tempname" "$tempname".c "$tempname".o
+    return $exitcode
 }
 
 EXE="$1"
 CC="$2"
-LDFLAGS="$3"
-O_FILES="$4"
-A_FILES="$5"
-LDLIBS="$6"
+CFLAGS="$3"
+LDFLAGS="$4"
+O_FILES="$5"
+A_FILES="$6"
+LDLIBS="$7"
 
-# The -Wl,--sort-section option is not supported by older versions of ld
-SORT_SECTION=`check_cc "-Wl,--sort-section -Wl,alignment" ""`
+# The --sort-section option is not supported by older versions of ld
+SORT_SECTION="-Wl,--sort-section,alignment"
+if ! check_cc "-Wl,--sort-section,alignment"; then
+    echo "Your linker does not support --sort-section,alignment"
+    SORT_SECTION=""
+fi
+
+START_GROUP="-Wl,--start-group"
+END_GROUP="-Wl,--end-group"
+INFO_OPTS() {
+       echo "-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
+}
+
+# gold may not support --sort-common (yet)
+SORT_COMMON="-Wl,--sort-common"
+if ! check_cc "-Wl,--sort-common"; then
+    echo "Your linker does not support --sort-common"
+    SORT_COMMON=""
+fi
+
+# Static linking against glibc produces buggy executables
+# (glibc does not cope well with ld --gc-sections).
+# See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
+# Note that glibc is unsuitable for static linking anyway.
+# We are removing -Wl,--gc-sections from link command line.
+GC_SECTIONS="-Wl,--gc-sections"
+if (. ./.config && test x"$CONFIG_STATIC" = x"y") then
+    if check_libc_is_glibc; then
+       echo "Static linking against glibc, can't use --gc-sections"
+       GC_SECTIONS=""
+    fi
+fi
+# The --gc-sections option is not supported by older versions of ld
+if test -n "$GC_SECTIONS"; then
+    if ! check_cc "$GC_SECTIONS"; then
+       echo "Your linker does not support $GC_SECTIONS"
+       GC_SECTIONS=""
+    fi
+fi
 
 # Sanitize lib list (dups, extra spaces etc)
 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
@@ -70,18 +128,20 @@ LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
 # First link with all libs. If it fails, bail out
 echo "Trying libraries: $LDLIBS"
 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
-l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
-try $CC $LDFLAGS \
+l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
+test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
+try $CC $CFLAGS $LDFLAGS \
        -o $EXE \
-       -Wl,--sort-common \
+       $SORT_COMMON \
        $SORT_SECTION \
-       -Wl,--gc-sections \
-       -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+       $GC_SECTIONS \
+       $START_GROUP $O_FILES $A_FILES $END_GROUP \
        $l_list \
 || {
-    echo "Failed: $* $l_list"
+    echo "Failed: $l_list"
     cat $EXE.out
+    echo 'Note: if build needs additional libraries, put them in CONFIG_EXTRA_LDLIBS.'
+    echo 'Example: CONFIG_EXTRA_LDLIBS="pthread dl tirpc audit pam"'
     exit 1
 }
 
@@ -89,52 +149,51 @@ try $CC $LDFLAGS \
 # Stop when no lib can be removed.
 while test "$LDLIBS"; do
     $debug && echo "Trying libraries: $LDLIBS"
-    all_needed=true
+    dropped_non_first_lib=false
+    first_lib=true
     for one in $LDLIBS; do
        without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
        # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
-       l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-       test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
+       l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
+       test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
        $debug && echo "Trying -l options: '$l_list'"
-       try $CC $LDFLAGS \
+       try $CC $CFLAGS $LDFLAGS \
                -o $EXE \
-               -Wl,--sort-common \
+               $SORT_COMMON \
                $SORT_SECTION \
-               -Wl,--gc-sections \
-               -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+               $GC_SECTIONS \
+               $START_GROUP $O_FILES $A_FILES $END_GROUP \
                $l_list
        if test $? = 0; then
-           echo "Library $one is not needed"
+           echo " Library $one is not needed, excluding it"
            LDLIBS="$without_one"
-           all_needed=false
+           $first_lib || dropped_non_first_lib=true
        else
-           echo "Library $one is needed"
+           echo " Library $one is needed, can't exclude it (yet)"
+           first_lib=false
        fi
     done
-    # All libs were needed, can't remove any
-    $all_needed && break
-    # If there is no space char, the list has just one lib.
-    # I'm not sure that in this case lib really is 100% needed.
-    # Let's try linking without it anyway... thus commented out.
-    #{ echo "$LDLIBS" | grep -q ' '; } || break
+    # We can stop trying to drop libs if either all libs were needed,
+    # or we excluded only the _first_ few.
+    # (else: we dropped some intermediate lib(s), maybe now we can succeed
+    # in dropping some of the preceding ones)
+    $dropped_non_first_lib || break
 done
 
 # Make the binary with final, minimal list of libs
-echo "Final link with: $LDLIBS"
-l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
+echo "Final link with: ${LDLIBS:-<none>}"
+l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
+test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
 # --verbose gives us gobs of info to stdout (e.g. linker script used)
 if ! test -f busybox_ldscript; then
-    try $CC $LDFLAGS \
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
-           -Wl,--gc-sections \
-           -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+           $GC_SECTIONS \
+           $START_GROUP $O_FILES $A_FILES $END_GROUP \
            $l_list \
-           -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
-           -Wl,--verbose \
+           `INFO_OPTS` \
     || {
        cat $EXE.out
        exit 1
@@ -147,17 +206,25 @@ else
     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
     # This will eliminate most of the padding (~3kb).
     # Hmm, "ld --sort-section alignment" should do it too.
-    try $CC $LDFLAGS \
+    #
+    # There is a ld hack which is meant to decrease disk usage
+    # at the cost of more RAM usage (??!!) in standard ld script:
+    #  /* Adjust the address for the data segment.  We want to adjust up to
+    #     the same address within the page on the next page up.  */
+    #  . = ALIGN (0x1000) - ((0x1000 - .) & (0x1000 - 1)); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
+    # Replace it with:
+    #  . = ALIGN (0x1000); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
+    # to unconditionally align .data to the next page boundary,
+    # instead of "next page, plus current offset in this page"
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
-           -Wl,--gc-sections \
-           -Wl,-T -Wl,busybox_ldscript \
-           -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+           $GC_SECTIONS \
+           -Wl,-T,busybox_ldscript \
+           $START_GROUP $O_FILES $A_FILES $END_GROUP \
            $l_list \
-           -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
-           -Wl,--verbose \
+           `INFO_OPTS` \
     || {
        cat $EXE.out
        exit 1
@@ -176,21 +243,23 @@ if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
     }
     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
 
+    # Yes, "ld -shared -static" is a thing. It's a shared library which is itself static.
+    LBB_STATIC=""
+    test "$CONFIG_FEATURE_LIBBUSYBOX_STATIC" = y && LBB_STATIC="-Wl,-static"
+
     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
-    try $CC $LDFLAGS \
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
-           -shared -fPIC \
+           -shared -fPIC $LBB_STATIC \
            -Wl,--enable-new-dtags \
            -Wl,-z,combreloc \
            -Wl,-soname="libbusybox.so.$BB_VER" \
            -Wl,--undefined=lbb_main \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
-           -Wl,--start-group $A_FILES -Wl,--end-group \
+           $START_GROUP $A_FILES $END_GROUP \
            $l_list \
-           -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
-           -Wl,--verbose \
+           `INFO_OPTS` \
     || {
        echo "Linking $EXE failed"
        cat $EXE.out
@@ -203,16 +272,15 @@ fi
 
 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
     EXE="$sharedlib_dir/busybox_unstripped"
-    try $CC $LDFLAGS \
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
-           -Wl,--gc-sections \
-           -Wl,--start-group $O_FILES -Wl,--end-group \
+           $GC_SECTIONS \
+           $START_GROUP $O_FILES $END_GROUP \
            -L"$sharedlib_dir" -lbusybox \
-           -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
-           -Wl,--verbose \
+           $l_list \
+           `INFO_OPTS` \
     || {
        echo "Linking $EXE failed"
        cat $EXE.out
@@ -224,9 +292,9 @@ fi
 
 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
-    gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
+    gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
     | grep -v "^#" \
-    | grep -v "^$" \
+    | grep -v "^ *$" \
     > applet_lst.tmp
     while read name main junk; do
 
@@ -242,11 +310,11 @@ int main(int argc, char **argv)
 " >"$sharedlib_dir/applet.c"
 
        EXE="$sharedlib_dir/$name"
-       try $CC $LDFLAGS "$sharedlib_dir/applet.c" \
+       try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
                -o $EXE \
-               -Wl,--sort-common \
+               $SORT_COMMON \
                $SORT_SECTION \
-               -Wl,--gc-sections \
+               $GC_SECTIONS \
                -L"$sharedlib_dir" -lbusybox \
                -Wl,--warn-common \
        || {
@@ -256,6 +324,8 @@ int main(int argc, char **argv)
        }
        rm -- "$sharedlib_dir/applet.c" $EXE.out
        $STRIP -s --remove-section=.note --remove-section=.comment $EXE
+       # Let user see that we do something - list the names of created binaries:
+       echo "$EXE"
 
     done <applet_lst.tmp
 fi